Description

Hello,

I saw that: r16108.

But actually, it could be great to be able to close a parent task.

Is it possible to allow this in the "configuration" of Redmine? For example:

"Allow a parent tracker to be closed even if the sub-task aren't: YES/NO".

 Thanks

Related issues:

Related to Redmine - Feature #10989: Prevent parent issue from being closed i... Closed

Related to Redmine - Feature #31322: Provide a way to automatically close all... New

Related to Redmine - Feature #31589: Show warning and the reason when the iss... Closed

Has duplicate Redmine - Feature #31321: Option not to block closing a parent ... Closed

History

#1 - 2018-08-07 17:24 - Go MAEDA

- Related to Feature #10989: Prevent parent issue from being closed if a child issue is open added

#2 - 2019-06-19 07:57 - Go MAEDA

- Has duplicate Feature #31322: Provide a way to automatically close all open subtasks too when a parent issue is being closed added

#3 - 2019-09-04 08:04 - Toshi MARUYAMA

- Description updated

#4 - 2019-09-04 08:05 - Toshi MARUYAMA

- Related to Feature #31321: Option not to block closing a parent issue when its subtask is open added

#5 - 2019-09-04 08:09 - Toshi MARUYAMA

- Subject changed from Close sub-tasks when closing a parent task to Option not to block closing a parent issue when its subtask is open

#6 - 2019-09-04 08:18 - Toshi MARUYAMA

- Related to deleted (Feature #31321: Option not to block closing a parent issue when its subtask is open)

#7 - 2019-09-04 08:19 - Toshi MARUYAMA

- Has duplicate Feature #31321: Option not to block closing a parent issue when its subtask is open added

#8 - 2019-09-18 07:46 - Toshi MARUYAMA

- File issue-28492.png added

- File issue-28492.diff added

This is patch.

2025-07-07 1/4

https://www.redmine.org/projects/redmine/repository/svn/revisions/16108


 issue-28492.png 

#9 - 2019-09-18 11:06 - Go MAEDA

Toshi MARUYAMA wrote:

This is patch.

 issue-28492.png 

 Thank you for writing the patch. The feature is beneficial for some users.

But I think it is better to change the setting name because "Close parent issue when its subtask is open" looks like a setting to automatically close

parent issues.

The following is my idea. Comments are welcome:

"Allow closing parent issue which has open subtasks"

"Allow closing parent issue whose subtasks are open"

#10 - 2019-09-19 08:01 - Toshi MARUYAMA

- Has duplicate deleted (Feature #31322: Provide a way to automatically close all open subtasks too when a parent issue is being closed)

#11 - 2019-09-19 08:01 - Toshi MARUYAMA

- Related to Feature #31322: Provide a way to automatically close all open subtasks too when a parent issue is being closed added

#12 - 2019-09-19 11:26 - Hinako Tajima

Toshi MARUYAMA, thank you for your contribution to writing the patch.

I agree with Go MAEDA to change the setting name to "Allow closing parent issue whose subtasks are open".

#13 - 2019-09-19 11:40 - Go MAEDA

- Target version set to Candidate for next major release

#14 - 2019-10-16 03:53 - Toshi MARUYAMA

- File issue-28492.ver.2.diff added

- File issue-28492.ver.2.png added

Hinako Tajima wrote:

Toshi MARUYAMA, thank you for your contribution to writing the patch.

I agree with Go MAEDA to change the setting name to "Allow closing parent issue whose subtasks are open".

 This is new patch.
#15 - 2020-01-05 09:31 - Mitsuyoshi Kawabata

Do you need this request? In what use cases is it necessary?

#16 - 2020-01-05 12:45 - Toshi MARUYAMA

- Related to Feature #31589: Show warning and the reason when the issue cannot be closed because of open subtasks or blocking open issue(s)

added

#17 - 2020-01-05 12:50 - Toshi MARUYAMA

Mitsuyoshi Kawabata wrote:

Do you need this request? In what use cases is it necessary?

 I think if #31322 is implemented, this feature is redundant.

#18 - 2020-01-06 13:37 - Mitsuyoshi Kawabata

Let me clear my point, I think allowing a parent issue to be closed when subtasks are still open is not really necessary.

How about just #31589 ? It would be simple and clear.
#19 - 2020-01-09 06:01 - Mischa The Evil

- Subject changed from Option not to block closing a parent issue when its subtask is open to Option not to block closing a parent issue when it has

open subtask(s)

FWIW: This issue is not related/being superseded by either #31322 or #31589. See my explanation in #31589#note-21.

Regarding this feature: I tend to agree with Mitsuyoshi Kawabata that I'm not seeing clear use-cases where it is logical to have closed parent issues

with open subtasks. I'd like some more feedback on this matter.

Though, if the decision is made to add this configuration option nevertheless, I'd propose the following T9N for the string

setting_close_parent_issue_whose_subtasks_are_open: "Allow closed parent issues with open subtasks" and a similar I18n string and setting name.

#20 - 2020-01-31 14:33 - Toshi MARUYAMA

- File issue-28492.ver.3.diff added

Mischa The Evil wrote:

I'd propose the following T9N for the string setting_close_parent_issue_whose_subtasks_are_open: "Allow closed parent issues with open

subtasks" and a similar I18n string and setting name.

 Changed.

#21 - 2020-03-11 23:06 - Go MAEDA

- Target version deleted (Candidate for next major release)

#22 - 2020-03-20 16:16 - Toshi MARUYAMA

- File issue-28492-20200321.diff added

Rebased on trunk r19598 because r19570 caused conflict.

#23 - 2020-06-25 14:38 - Felix Schäfer

Some not-so-quick notes from Planio regarding this issue: r16108 was a breaking change for our existing users, some of which depended on and had

built workflows around being able to have closed parent issues with open child issues. To alleviate this issue for existing users we have back ported

the diff attached to this issue and enabled the setting to restore the "old" behaviour for existing users. New users will use the new behaviour by

default.

We understand the need to make breaking changes sometimes, though having a setting would make that less breaking of a change for us: We could

then set existing users to use the before breaking change behaviour and new users with the after breaking change behaviour.

We have discussed this matter internally in addition to already reading what has been discussed here. We also currently have no use-case for open

subissues with closed parent issues, but this does not mean it is not a valid use-case. Several Planio users were impacted when we introduced this

change on Planio.

We think Redmine is a very capable, malleable and configurable system and would like to contribute to keep it that way. Redmine does not impose

certain types of trackers (you can configure more than just "Bug", "Feature" and "Support"), can be configured with arbitrary statuses and workflows in

those statuses, Redmine can even have custom fields for issues and other things. We feel it is antithetical to the configurability of Redmine to not

have a setting for this.

While thinking about this we also had an idea that might help assuage some concerns regarding this setting. We think adding this setting to trackers

instead of a global setting could allow for more rich configurations and workflows in Redmine. You could then configure trackers to allow or to not

allow closing when there are open subissues and vice-versa. Maybe the "inverse" setting would also be helpful: automatically closing parent issues

with a certain tracker when all subissues are closed.

Thank you for reading and thank you for your work and care with Redmine.

#24 - 2022-08-29 11:18 - Dennis Buehring

I know this is an older issue, but we just ran into this feature/issue because we jumped from Redmine 3.x.x to 4.2.7

Personally i dont see a need for closed issues with open sub-issues... but it seems our users decided otherwise over the years.

I agree with Felix that this shouldn't be a global setting, but it should be configurable somewhere.. e.g. project or tracker level

Felix Schäfer did you stick with your backport ?
